/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 *
 * Section BF
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0
/* define START and END text sequences*/
#define START 1
#define END 0
#define WIN 3
/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTT 5


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0
/*********************************************
number of other cars possible*/
#define CARS 10

/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	1

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/


/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int traffic_moving[], int car_speed[],
				   int car_direction[], int car_color[],int lane[]);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
int move_traffic(int x[], int lane[], int direction[], int car_speed[], int *increment,
				  int crashed[],int existence[]);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[], int lane[], int color[],int crashed[],int existence[], int car_speed[],
				  int *counter);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

void draw_crash(int x,int y, int *counter);
/* draw instructions and wait for mouse click to begin game*/
void draw_instruction (int );

/* Display error message if internal error is detected. */
void something_is_wrong (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/
	int increment=0;

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	/* [Only one car now - will need to be changed to add more]				*/
	int car_x[CARS], lane[CARS];		/* current position of the car					*/
	int car_direction[CARS];		/* current direction: +1=right, -1=left			*/
	int car_color[CARS];			/* color of the car								*/
	int car_speed[CARS];			/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving[CARS];		/* = "traffic is currently moving"				*/
	int crashed[CARS];				/* Check status of car */
	int existence[CARS]	;		/* Does car actually exist, can it be seen  I didn't actually 
	use this but it would be a nice feature for making the game harder or easier*/
	int k;
	int counter=0;					/* Use counter to animate flames in draw_crash*/
	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial conditions for the car */
	
	for(k=0;k<CARS;k++)
	{
	car_x[k] = k*3;
	if(k<7)
		lane[k]=k;
	else
		lane[k]=k-6;
	car_direction[k] = +1;
	car_speed[k] = k+1+k%5;
	car_color[k] = k;
	traffic_moving[k] = TRUE;
	crashed[k]=FALSE;
	existence[k]=TRUE;}
	car_speed[0]=10;
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y);
	draw_buttons( );
	draw_traffic(car_x, lane, car_color, crashed, existence, car_speed, &counter);
	/* Show instructions for game and wait for mouse click*/
	draw_instruction(START);




	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, traffic_moving, car_speed,
								car_direction, car_color,lane);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
			
			
			quit=move_traffic(car_x, lane, car_direction, car_speed,&increment,crashed,
				existence);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y);
		draw_buttons();
		draw_traffic(car_x, lane, car_color, crashed, existence,car_speed, &counter);
		
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */

/*****************************************
Instructions drawn on screen waite for mouse click*/
void draw_instruction(int condition)
{	int wait=TRUE;
	int mouse_x, mouse_y;
	char key_pressed;
	int event;
	while( wait!=FALSE)
		if(condition==START)
		{event=GP142_await_event(&mouse_x, &mouse_y,&key_pressed);
		
			GP142_printfXY (BLACK, 0, 0, 16, "It's 2021... post-revolution\n"
					"You are one of the legions of road warriors!\n"
					"Your job is to wreck every car you see!!!\n"
					"Your black car is equiped with a \ncrash resitant alloy\n"
					"Unfortunatly, this alloy is highly flamable!!\n"
					" Don't run into any explosions!!\n");	
		
			if(event==GP142_MOUSE)
			wait=FALSE;}

		else if(condition==END)
			{event=GP142_await_event(&mouse_x, &mouse_y,&key_pressed);
		
				GP142_printfXY (RED, 0, 0, 16, "YOU LOSE DUDE!!!!!!!!!!");	
		
			if(event==GP142_MOUSE)
			wait=FALSE;}
		else 
			{event=GP142_await_event(&mouse_x, &mouse_y,&key_pressed);
		
				GP142_printfXY (WHITE, 0, 0, 16, "YOU WIN!!!!!");	
		
			if(event==GP142_MOUSE)
			wait=FALSE;}
	
		

	
}

/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */
	int j;
	
	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	/*draw highway lanes*/
	for(j=1;j<7;j++)
	{

	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER- (j-1)*HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER - j*HIGHWAY_WIDTH,
					 FILL);
	GP142_rectangleXY(BLACK,
					-GP142_XMAX-10, HIGHWAY_CENTER-(j-1)*HIGHWAY_WIDTH,
					GP142_XMAX, HIGHWAY_CENTER- j*HIGHWAY_WIDTH,1);
  
	}
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");

	
	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);
	
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
	void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTT; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");

	i-= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset,i,font_size,"Up");
	i-= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset,i,font_size,"Down");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTT*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int traffic_moving[CARS], int car_speed[CARS],
				   int car_direction[CARS], int car_color[CARS],int lane[CARS])
{
	int buttonNum,k=0;/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	
	{
	

		
	case 0:
		/* speed up */
		car_speed[k] = car_speed[k] + 1;
		break;
	case 1:
		/* slow down */
		car_speed[k] = car_speed[k] - 1;
		if (car_speed[k] < 0)
			car_speed[k] = 0;
		break;
		
	case 2:
		/* reverse */
		car_direction[k] = - car_direction[k];
		break;
	case 3:
		/* Move car up one lane*/
		
		(lane[k])--;
		break;
	case 4:
		/* Move car down one lane*/
		
		(lane[k])++;
		break;
	default:

		/*Bad news if this is ever reached! */
		something_is_wrong();
	}	break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
int move_traffic(int x[CARS], int lane[CARS], int direction[CARS], int car_speed[CARS],
				  int *increment, int crashed[CARS], int existence[CARS])
 {
	/* variables to control random variables*/
	int ran, updown;

	int trial_x;		/* new value for x coordinate */
	int k;
	/* count the number of crashes so win can be determined*/
	int crashcount=0;
	/* intialize random variables*/
	ran=rand()%10;
	updown=rand()%2;




	
  for(k=0;k<CARS;k++)

{ /* add incrementer so that cars gradually get faster*/
		if ((*increment)%100==1)
			car_speed[k]++;
	/*count to see how many cars are crashed so win can be assesed*/
		if(crashed[k]==TRUE) crashcount++;
		if (crashcount==CARS-1) 
		{draw_instruction(WIN); return TRUE;}
		
		
		
	trial_x = x[k] + (direction[k] * car_speed[k]);
	/* if car goes off the screen, appears on other side*/
	if ((trial_x>GP142_XMAX+CAR_WIDTH/2)&& (direction[k]==1 ))
      x[k]=-GP142_XMAX-CAR_WIDTH/2;
		else if((trial_x<-GP142_XMAX-CAR_WIDTH/2)&&(direction[k]==-1))
		x[k]=GP142_XMAX+CAR_WIDTH/2;
			else
			x[k] = trial_x;
	/*Check to see if cars are on the road, if they go off, put them back on*/
	if(lane[k]>6) lane[k]=6;
	if(lane[k]<0)  lane[k]=0;

	}
	/* check to see if cars crashed if so then change array crashed, also change lanes randomly*/
	for(k=1;k<CARS;k++)
	{
		/*randomly move a car up or down*/		
		if((k==ran && updown==0)&&crashed[k]==FALSE) lane[k]++;
			else if((k==ran && updown==1)&& crashed[k]==FALSE) lane[k]--;


		/*check to see if car 0 hit an explosion*/
	if (((abs(x[0]-x[k])<CAR_WIDTH/(4)) && (lane[0]==lane[k])) && crashed[k]==TRUE)
		{draw_instruction(END);
		return TRUE;}
		/*check to see if car 0 hit another car*/
	if(   ((abs(x[0]-x[k])<CAR_WIDTH)  &&  (lane[0]==lane[k])) && existence[k]==TRUE)
		crashed[k]=TRUE;
		
	 
	}
return FALSE;
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[CARS], int lane[CARS], int color[CARS],int crashed[CARS], 
				  int existence[CARS], int car_speed[CARS], int *counter) 
{
	
	int y,k ;
	/* Need way to correct crash animation bug when # of crashed cars
	in /3, so when Crash #%3==0 then *counter++; count keeps track of crash number*/
	for(k=0;k<CARS;k++)
	{	y=0;	
		/*Convert lane # into y coordinate*/
		y=HIGHWAY_CENTER-lane[k]*HIGHWAY_WIDTH;
		/* If car is not crashed and exists, then draw it*/
		if((existence[k]==TRUE) && (crashed[k]==FALSE))	
		draw_car(x[k],y,color[k]);
		/* If car  is crashed and exists, draw the grisly crash*/
		if((existence[k]==TRUE) && (crashed[k]==TRUE))
		{draw_crash(x[k],y, counter); 
		/* Stop wrecked car*/
		car_speed[k]=0;
		
		}

	}
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);
	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
}

void draw_crash(int x, int y, int *counter)
{	
	(*counter)++;	

	if(*counter%3==0)	
	GP142_circleXY(YELLOW,x,y , 7);
	else if(*counter%3==1)
	GP142_circleXY(ORANGE,x,y , 9);
	else
		GP142_circleXY(RED,x,y , 11);


}


/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}